Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/export.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/export.py	(revision 9252)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/export.py	(revision 9253)
@@ -105,5 +105,6 @@
     fields = tuple(sorted(iface_names(
         IStudent, omit=['loggerInfo']))) + (
-        'password', 'state', 'history', 'certcode')
+        'password', 'state', 'history', 'certcode', 'is_postgrad',
+        'current_level', 'current_session')
 
     #: The title under which this exporter will be displayed
@@ -176,5 +177,6 @@
     #: Fieldnames considered by this exporter
     fields = tuple(sorted(iface_names(
-        IStudentStudyLevel) + ['level'])) + ('student_id', 'number_of_tickets')
+        IStudentStudyLevel) + ['level'])) + (
+        'student_id', 'number_of_tickets','certcode')
 
     #: The title under which this exporter will be displayed
@@ -209,5 +211,5 @@
     fields = tuple(sorted(iface_names(ICourseTicket) +
         ['level', 'code', 'title', 'credits',
-        'passmark', 'semester', 'fcode', 'dcode'])) + ('student_id',)
+        'passmark', 'semester', 'fcode', 'dcode'])) + ('student_id', 'certcode')
 
     #: The title under which this exporter will be displayed
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/interfaces.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/interfaces.py	(revision 9252)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/interfaces.py	(revision 9253)
@@ -429,4 +429,5 @@
     level = Attribute('The level code')
     number_of_tickets = Attribute('Number of tickets contained in this level')
+    certcode = Attribute('The certificate code of the study course')
 
     level_session = schema.Choice(
@@ -470,4 +471,5 @@
     fcode = Attribute('faculty code of the original course')
     dcode = Attribute('department code of the original course')
+    certcode = Attribute('certificate code of the study course')
 
     mandatory = schema.Bool(
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/studylevel.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/studylevel.py	(revision 9252)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/studylevel.py	(revision 9253)
@@ -43,4 +43,11 @@
         try:
             return self.__parent__.__parent__
+        except AttributeError:
+            return None
+
+    @property
+    def certcode(self):
+        try:
+            return self.__parent__.certificate.code
         except AttributeError:
             return None
@@ -124,4 +131,11 @@
             return None
 
+    @property
+    def certcode(self):
+        try:
+            return self.__parent__.__parent__.certificate.code
+        except AttributeError:
+            return None
+
     def writeLogMessage(self, view, message):
         return self.__parent__.__parent__.__parent__.writeLogMessage(view, message)
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py	(revision 9252)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py	(revision 9253)
@@ -45,5 +45,5 @@
             'firstname,lastname,matric_number,middlename,nationality,'
             'perm_address,phone,reg_number,sex,student_id,suspended,password,'
-            'state,history,certcode\r\n'
+            'state,history,certcode,is_postgrad,current_level,current_session\r\n'
 
             'my adm code,0,my clr code,1981-02-04#,anna@sample.com,,'
@@ -65,5 +65,5 @@
             'firstname,lastname,matric_number,middlename,nationality,'
             'perm_address,phone,reg_number,sex,student_id,suspended,password,'
-            'state,history,certcode\r\n'
+            'state,history,certcode,is_postgrad,current_level,current_session\r\n'
 
             'my adm code,0,my clr code,1981-02-04#,anna@sample.com,,'
@@ -84,5 +84,5 @@
             'firstname,lastname,matric_number,middlename,nationality,'
             'perm_address,phone,reg_number,sex,student_id,suspended,password,'
-            'state,history,certcode\r\n'
+            'state,history,certcode,is_postgrad,current_level,current_session\r\n'
 
             'my adm code,0,my clr code,1981-02-04#,anna@sample.com,,'
@@ -210,6 +210,6 @@
             result,
             'level,level_session,level_verdict,validated_by,validation_date,'
-            'student_id,number_of_tickets\r\n'
-            ',,0,,,,0\r\n'
+            'student_id,number_of_tickets,certcode\r\n'
+            ',,0,,,,0,\r\n'
             )
         return
@@ -227,6 +227,6 @@
             result,
             'level,level_session,level_verdict,validated_by,validation_date,'
-            'student_id,number_of_tickets\r\n'
-            '100,2012,A,,,A111111,1\r\n'
+            'student_id,number_of_tickets,certcode\r\n'
+            '100,2012,A,,,A111111,1,CERT1\r\n'
             )
         return
@@ -242,6 +242,6 @@
             result,
             'level,level_session,level_verdict,validated_by,validation_date,'
-            'student_id,number_of_tickets\r\n'
-            '100,2012,A,,,A111111,1\r\n'
+            'student_id,number_of_tickets,certcode\r\n'
+            '100,2012,A,,,A111111,1,CERT1\r\n'
             )
         return
@@ -256,6 +256,6 @@
             result,
             'level,level_session,level_verdict,validated_by,validation_date,'
-            'student_id,number_of_tickets\r\n'
-            '100,2012,A,,,A111111,1\r\n'
+            'student_id,number_of_tickets,certcode\r\n'
+            '100,2012,A,,,A111111,1,CERT1\r\n'
             )
         return
@@ -292,6 +292,6 @@
             result,
             'automatic,carry_over,code,credits,dcode,fcode,level,mandatory,'
-            'passmark,score,semester,title,student_id\r\n'
-            '0,0,,,,,,0,,0,,,\r\n'
+            'passmark,score,semester,title,student_id,certcode\r\n'
+            '0,0,,,,,,0,,0,,,,\r\n'
             )
         return
@@ -310,6 +310,6 @@
             result,
             'automatic,carry_over,code,credits,dcode,fcode,level,mandatory,'
-            'passmark,score,semester,title,student_id\r\n'
-            '1,1,CRS1,100,DEP1,FAC1,100,0,100,0,2,Course 1,A111111\r\n'
+            'passmark,score,semester,title,student_id,certcode\r\n'
+            '1,1,CRS1,100,DEP1,FAC1,100,0,100,0,2,Course 1,A111111,CERT1\r\n'
             )
         return
@@ -325,6 +325,6 @@
             result,
             'automatic,carry_over,code,credits,dcode,fcode,level,mandatory,'
-            'passmark,score,semester,title,student_id\r\n'
-            '1,1,CRS1,100,DEP1,FAC1,100,0,100,0,2,Course 1,A111111\r\n'
+            'passmark,score,semester,title,student_id,certcode\r\n'
+            '1,1,CRS1,100,DEP1,FAC1,100,0,100,0,2,Course 1,A111111,CERT1\r\n'
             )
         return
@@ -339,6 +339,6 @@
             result,
             'automatic,carry_over,code,credits,dcode,fcode,level,mandatory,'
-            'passmark,score,semester,title,student_id\r\n'
-            '1,1,CRS1,100,DEP1,FAC1,100,0,100,0,2,Course 1,A111111\r\n'
+            'passmark,score,semester,title,student_id,certcode\r\n'
+            '1,1,CRS1,100,DEP1,FAC1,100,0,100,0,2,Course 1,A111111,CERT1\r\n'
             )
         return