Index: main/waeup.futminna/trunk/src/waeup/futminna/interswitch/browser.py
===================================================================
--- main/waeup.futminna/trunk/src/waeup/futminna/interswitch/browser.py	(revision 9291)
+++ main/waeup.futminna/trunk/src/waeup/futminna/interswitch/browser.py	(revision 9292)
@@ -197,71 +197,87 @@
         xmldict['institution_acct'] = '000000000000'
         xmldict['institution_bank_id'] = '00'
-        xmldict['institution_amt'] = 100 * (self.context.amount_auth - provider_amt - 300)
-
-        if self.context.student.current_mode in ('pg_ft'):
-            self.pay_item_id = "11703"
-        elif self.context.student.state == CLEARED and \
-            self.context.student.current_level == 100:
-            self.pay_item_id = "11700"
-        elif self.context.student.state == CLEARED and \
-            self.context.student.current_level == 200:
-            self.pay_item_id = "11701"
-        elif self.context.student.state == CLEARED and \
-            self.context.student.current_level == 300:
-            self.pay_item_id = "11702"
-        elif self.context.student.state == RETURNING and \
-            self.context.student.current_level in (100,110):
-            self.pay_item_id = "11701"
-        elif self.context.student.state == RETURNING and \
-            self.context.student.current_level in (200,210):
-            self.pay_item_id = "11702"
-        elif self.context.student.state == RETURNING and \
-            self.context.student.current_level in (300,310):
-            self.pay_item_id = "11703"
-        elif self.context.student.state == RETURNING and \
-            self.context.student.current_level in (400,410,500,510,600):
-            self.pay_item_id = "11704"
-
-
-        if self.context.student.current_mode == 'jm_ft':
-            xmldict['institution_acct'] = "000000000000"
-            xmldict['institution_bank_id'] = '0'
-        elif self.context.student.current_mode == 'pg_ft':
-            xmldict['institution_acct'] = "2522040000134"
-            xmldict['institution_bank_id'] = '8'
-        elif self.context.student.state == CLEARED and \
-            self.context.student.current_level == 100:
-            xmldict['institution_acct'] = "0030001000017110"
-            xmldict['institution_bank_id'] = '89'
-        elif self.context.student.state == CLEARED and \
-            self.context.student.current_level == 200:
-            xmldict['institution_acct'] = "0591201005146"
-            xmldict['institution_bank_id'] = '101'
-        elif self.context.student.state == CLEARED and \
-            self.context.student.current_level == 300:
-            xmldict['institution_acct'] = "6013803345"
-            xmldict['institution_bank_id'] = '117'
-        elif self.context.student.state == RETURNING and \
-            self.context.student.current_level in (100,110):
-            xmldict['institution_acct'] = "0591201005146"
-            xmldict['institution_bank_id'] = '101'
-        elif self.context.student.current_level in (200,210):
-            xmldict['institution_acct'] = "6013803345"
-            xmldict['institution_bank_id'] = '117'
-        elif self.context.student.current_level in (300,310):
-            xmldict['institution_acct'] = "2522040000134"
-            xmldict['institution_bank_id'] = '8'
-        #Change of acct from UBA to GTBank
-        elif self.context.student.current_level in (400,410,500,510,600):
-            xmldict['institution_acct'] = "3713516838111"
-            xmldict['institution_bank_id'] = '10'
+        
+        if self.context.p_category == 'schoolfee':
+            xmldict['institution_amt'] = 100 * (
+                self.context.amount_auth - provider_amt - 300)
+            if self.context.student.current_mode in ('pg_ft'):
+                self.pay_item_id = "11703"
+            elif self.context.student.state == CLEARED and \
+                self.context.student.current_level == 100:
+                self.pay_item_id = "11700"
+            elif self.context.student.state == CLEARED and \
+                self.context.student.current_level == 200:
+                self.pay_item_id = "11701"
+            elif self.context.student.state == CLEARED and \
+                self.context.student.current_level == 300:
+                self.pay_item_id = "11702"
+            elif self.context.student.state == RETURNING and \
+                self.context.student.current_level in (100,110):
+                self.pay_item_id = "11701"
+            elif self.context.student.state == RETURNING and \
+                self.context.student.current_level in (200,210):
+                self.pay_item_id = "11702"
+            elif self.context.student.state == RETURNING and \
+                self.context.student.current_level in (300,310):
+                self.pay_item_id = "11703"
+            elif self.context.student.state == RETURNING and \
+                self.context.student.current_level in (400,410,500,510,600):
+                self.pay_item_id = "11704"
+
+            if self.context.student.current_mode == 'jm_ft':
+                xmldict['institution_acct'] = "000000000000"
+                xmldict['institution_bank_id'] = '0'
+            elif self.context.student.current_mode == 'pg_ft':
+                xmldict['institution_acct'] = "2522040000134"
+                xmldict['institution_bank_id'] = '8'
+            elif self.context.student.state == CLEARED and \
+                self.context.student.current_level == 100:
+                xmldict['institution_acct'] = "0030001000017110"
+                xmldict['institution_bank_id'] = '89'
+            elif self.context.student.state == CLEARED and \
+                self.context.student.current_level == 200:
+                xmldict['institution_acct'] = "0591201005146"
+                xmldict['institution_bank_id'] = '101'
+            elif self.context.student.state == CLEARED and \
+                self.context.student.current_level == 300:
+                xmldict['institution_acct'] = "6013803345"
+                xmldict['institution_bank_id'] = '117'
+            elif self.context.student.state == RETURNING and \
+                self.context.student.current_level in (100,110):
+                xmldict['institution_acct'] = "0591201005146"
+                xmldict['institution_bank_id'] = '101'
+            elif self.context.student.current_level in (200,210):
+                xmldict['institution_acct'] = "6013803345"
+                xmldict['institution_bank_id'] = '117'
+            elif self.context.student.current_level in (300,310):
+                xmldict['institution_acct'] = "2522040000134"
+                xmldict['institution_bank_id'] = '8'
+            #Change of acct from UBA to GTBank
+            elif self.context.student.current_level in (400,410,500,510,600):
+                xmldict['institution_acct'] = "3713516838111"
+                xmldict['institution_bank_id'] = '10'
+
+        elif self.context.p_category == 'clearance':
+            xmldict['institution_amt'] = 100 * (
+                self.context.amount_auth - 300)
+            xmldict['institution_acct'] = "1750005063"
+            xmldict['institution_bank_id'] = '120'
+            self.pay_item_id = "11706"
 
         xmldict['institution_item_name'] = self.context.p_category
         xmldict['institution_name'] = INSTITUTION_NAME
         # Interswitch amount is not part of the xml data
-        xmltext = """<payment_item_detail>
+
+        if self.context.p_category == 'schoolfee':
+            xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
 <item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
 <item_detail item_id="2" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
+</item_details>
+</payment_item_detail>""" % xmldict
+        elif self.context.p_category == 'clearance':
+            xmltext = """<payment_item_detail>
+<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
+<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
 </item_details>
 </payment_item_detail>""" % xmldict